import * as config from 'config'
import { isTestInstance } from '../helpers/core-utils'

const API_VERSION = 'v1'

const CONFIG = {
  LISTEN: {
    PORT: config.get<number>('listen.port')
  },
  ELASTIC_SEARCH: {
    HOSTNAME: config.get<string>('elastic_search.hostname'),
    PORT: config.get<number>('elastic_search.port'),
    INDEXES: {
      VIDEOS: config.get<string>('elastic_search.indexes.videos')
    }
  },
  LOG: {
    LEVEL: config.get<string>('log.level')
  },
  INSTANCES_URL: {
    URL: config.get<string>('instances-index.url')
  }
}

const SORTABLE_COLUMNS = {
}

const PAGINATION_COUNT_DEFAULT = 20

const SCHEDULER_INTERVALS_MS = {
  videosIndexer: 60000 * 60 * 12 // 12 hours
}

const INDEXER_COUNT = {
  VIDEOS: 1
}

if (isTestInstance()) {
  SCHEDULER_INTERVALS_MS.videosIndexer = 10000
}

export {
  CONFIG,
  API_VERSION,
  PAGINATION_COUNT_DEFAULT,
  SORTABLE_COLUMNS,
  SCHEDULER_INTERVALS_MS,
  INDEXER_COUNT
}
